# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'AnalyzerConfiguration',
    'AnalyzerConfigurationUnusedAccess',
    'AnalyzerConfigurationUnusedAccessAnalysisRule',
    'AnalyzerConfigurationUnusedAccessAnalysisRuleExclusion',
    'ArchiveRuleFilter',
]

@pulumi.output_type
class AnalyzerConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "unusedAccess":
            suggest = "unused_access"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AnalyzerConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AnalyzerConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AnalyzerConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 unused_access: Optional['outputs.AnalyzerConfigurationUnusedAccess'] = None):
        """
        :param 'AnalyzerConfigurationUnusedAccessArgs' unused_access: A block that specifies the configuration of an unused access analyzer for an AWS organization or account. Documented below
        """
        if unused_access is not None:
            pulumi.set(__self__, "unused_access", unused_access)

    @property
    @pulumi.getter(name="unusedAccess")
    def unused_access(self) -> Optional['outputs.AnalyzerConfigurationUnusedAccess']:
        """
        A block that specifies the configuration of an unused access analyzer for an AWS organization or account. Documented below
        """
        return pulumi.get(self, "unused_access")


@pulumi.output_type
class AnalyzerConfigurationUnusedAccess(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "analysisRule":
            suggest = "analysis_rule"
        elif key == "unusedAccessAge":
            suggest = "unused_access_age"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AnalyzerConfigurationUnusedAccess. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AnalyzerConfigurationUnusedAccess.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AnalyzerConfigurationUnusedAccess.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 analysis_rule: Optional['outputs.AnalyzerConfigurationUnusedAccessAnalysisRule'] = None,
                 unused_access_age: Optional[builtins.int] = None):
        """
        :param 'AnalyzerConfigurationUnusedAccessAnalysisRuleArgs' analysis_rule: A block for analysis rules. Documented below
        :param builtins.int unused_access_age: The specified access age in days for which to generate findings for unused access.
        """
        if analysis_rule is not None:
            pulumi.set(__self__, "analysis_rule", analysis_rule)
        if unused_access_age is not None:
            pulumi.set(__self__, "unused_access_age", unused_access_age)

    @property
    @pulumi.getter(name="analysisRule")
    def analysis_rule(self) -> Optional['outputs.AnalyzerConfigurationUnusedAccessAnalysisRule']:
        """
        A block for analysis rules. Documented below
        """
        return pulumi.get(self, "analysis_rule")

    @property
    @pulumi.getter(name="unusedAccessAge")
    def unused_access_age(self) -> Optional[builtins.int]:
        """
        The specified access age in days for which to generate findings for unused access.
        """
        return pulumi.get(self, "unused_access_age")


@pulumi.output_type
class AnalyzerConfigurationUnusedAccessAnalysisRule(dict):
    def __init__(__self__, *,
                 exclusions: Optional[Sequence['outputs.AnalyzerConfigurationUnusedAccessAnalysisRuleExclusion']] = None):
        """
        :param Sequence['AnalyzerConfigurationUnusedAccessAnalysisRuleExclusionArgs'] exclusions: A block for the analyzer rules containing criteria to exclude from analysis. Documented below
        """
        if exclusions is not None:
            pulumi.set(__self__, "exclusions", exclusions)

    @property
    @pulumi.getter
    def exclusions(self) -> Optional[Sequence['outputs.AnalyzerConfigurationUnusedAccessAnalysisRuleExclusion']]:
        """
        A block for the analyzer rules containing criteria to exclude from analysis. Documented below
        """
        return pulumi.get(self, "exclusions")


@pulumi.output_type
class AnalyzerConfigurationUnusedAccessAnalysisRuleExclusion(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "accountIds":
            suggest = "account_ids"
        elif key == "resourceTags":
            suggest = "resource_tags"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AnalyzerConfigurationUnusedAccessAnalysisRuleExclusion. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AnalyzerConfigurationUnusedAccessAnalysisRuleExclusion.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AnalyzerConfigurationUnusedAccessAnalysisRuleExclusion.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 account_ids: Optional[Sequence[builtins.str]] = None,
                 resource_tags: Optional[Sequence[Mapping[str, builtins.str]]] = None):
        """
        :param Sequence[builtins.str] account_ids: A list of account IDs to exclude from the analysis.
        :param Sequence[Mapping[str, builtins.str]] resource_tags: A list of key-value pairs for resource tags to exclude from the analysis.
        """
        if account_ids is not None:
            pulumi.set(__self__, "account_ids", account_ids)
        if resource_tags is not None:
            pulumi.set(__self__, "resource_tags", resource_tags)

    @property
    @pulumi.getter(name="accountIds")
    def account_ids(self) -> Optional[Sequence[builtins.str]]:
        """
        A list of account IDs to exclude from the analysis.
        """
        return pulumi.get(self, "account_ids")

    @property
    @pulumi.getter(name="resourceTags")
    def resource_tags(self) -> Optional[Sequence[Mapping[str, builtins.str]]]:
        """
        A list of key-value pairs for resource tags to exclude from the analysis.
        """
        return pulumi.get(self, "resource_tags")


@pulumi.output_type
class ArchiveRuleFilter(dict):
    def __init__(__self__, *,
                 criteria: builtins.str,
                 contains: Optional[Sequence[builtins.str]] = None,
                 eqs: Optional[Sequence[builtins.str]] = None,
                 exists: Optional[builtins.str] = None,
                 neqs: Optional[Sequence[builtins.str]] = None):
        """
        :param builtins.str criteria: Filter criteria.
        :param Sequence[builtins.str] contains: Contains comparator.
        :param Sequence[builtins.str] eqs: Equals comparator.
        :param builtins.str exists: Boolean comparator.
        :param Sequence[builtins.str] neqs: Not Equals comparator.
        """
        pulumi.set(__self__, "criteria", criteria)
        if contains is not None:
            pulumi.set(__self__, "contains", contains)
        if eqs is not None:
            pulumi.set(__self__, "eqs", eqs)
        if exists is not None:
            pulumi.set(__self__, "exists", exists)
        if neqs is not None:
            pulumi.set(__self__, "neqs", neqs)

    @property
    @pulumi.getter
    def criteria(self) -> builtins.str:
        """
        Filter criteria.
        """
        return pulumi.get(self, "criteria")

    @property
    @pulumi.getter
    def contains(self) -> Optional[Sequence[builtins.str]]:
        """
        Contains comparator.
        """
        return pulumi.get(self, "contains")

    @property
    @pulumi.getter
    def eqs(self) -> Optional[Sequence[builtins.str]]:
        """
        Equals comparator.
        """
        return pulumi.get(self, "eqs")

    @property
    @pulumi.getter
    def exists(self) -> Optional[builtins.str]:
        """
        Boolean comparator.
        """
        return pulumi.get(self, "exists")

    @property
    @pulumi.getter
    def neqs(self) -> Optional[Sequence[builtins.str]]:
        """
        Not Equals comparator.
        """
        return pulumi.get(self, "neqs")


